<?php
// Copyright (C) 2011 by TOMITA Hiroshi.
//     This program is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.

//     This program is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.

//     You should have received a copy of the GNU General Public License
//     along with this program.  If not, see <http://www.gnu.org/licenses/>.

// method: post

require_once('zip.lib.php');
ini_set('display_errors' ,1);
ini_set('date.timezone' ,"Asia/Tokyo");
error_reporting(E_ERROR);

// for disabling magic-quote 
// http://www.php.net/manual/en/security.magicquotes.disabling.php
if (get_magic_quotes_gpc()) {
    $process = array(&$_GET, &$_POST, &$_COOKIE, &$_REQUEST);
    while (list($key, $val) = each($process)) {
        foreach ($val as $k => $v) {
            unset($process[$key][$k]);
            if (is_array($v)) {
                $process[$key][stripslashes($k)] = $v;
                $process[] = &$process[$key][stripslashes($k)];
            } else {
                $process[$key][stripslashes($k)] = stripslashes($v);
            }
        }
    }
    unset($process);
}

function filename_safe($filename) {
    $temp = $filename;

    // Lower case
    $temp = strtolower($temp);

    // Replace spaces with a '_'
    $temp = str_replace(" ", "_", $temp);

    // Loop through string
    $result = '';
    for ($i=0; $i<strlen($temp); $i++) {
        if (preg_match('([0-9]|[a-z]|_)', $temp[$i])) {
            $result = $result . $temp[$i];
        }    
    }

    return $result;
}

$zip = new zipfile();

list($dummy,$jpg64) = explode(",",$_POST['img64'],2);

$title = filename_safe($_POST['title']);

$zip -> addFile($_POST['artisoc'], $title.'.model');
$zip -> addFile($_POST['raw'], "raw.json");
$zip -> addFile($_POST['temp'], "temp.json");
$zip -> addFile(base64_decode($jpg64), "background.jpg");

header('Content-Type: application/octet-stream');
header("Content-Disposition: attachment; filename=\"".$title.".zip\"");

print($zip->file());
?>
